'' ::::::::::::::::::::::::::::::::::::::::::::::::::::
'' :: Full Screen Editor  1.2         By Jeff Ledger ::
'' ::                                                ::
'' :: This is the start of a full featured editor    ::
'' :: for the Propeller.  Currently it only supports ::
'' :: a single screen.  It will be expanded in later ::
'' :: releases.                                      ::
'' ::::::::::::::::::::::::::::::::::::::::::::::::::::
'' Thanks to Doug,Baggers,Hippy and others who have contributed to
'' the great text driver used by this code.
''
'' Finally dawned on me what the problem was with this editor!
'' text loss bugs fixed!
'' restricted keyboard cursor controls to actual data like notepad.
''
'' A few minor issues remain, but I believe it works well enough
'' to be a useful tool.
CON
  '' I/O SETTINGS
  
  '' Uncomment section for your configuration type:

'' Demoboard/Protoboard/SpinStudio Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 5_000_000
  
   keyboard  = 26 '' I/O for keyboard connection
   video     = 12 '' I/O for composite video connection 

   spiDO     = 0
   spiClk    = 1
   spiDI     = 2
   spiCS     = 3

{
'' Hydra Boards
   _clkmode  = xtal1 + pll8x
   _xinfreq  = 10_000_000

   keyboard  = 13 '' I/O for keyboard connection 
   video     = 24 '' I/O for composite video connection
    
   spiDO     = 16
   spiClk    = 17
   spiDI     = 18
   spiCS     = 19
}   

{
'' Hybrid Boards
   _clkmode  = xtal1 + pll16x
   _xinfreq  = 6_000_000

   keyboard  = 12 '' I/O for keyboard connection 
   video     = 24 '' I/O for composite video connection 
  
   spiDO     = 16
   spiClk    = 17
   spiDI     = 18
   spiCS     = 19

}


   

  
 '' Basic Color Settings

  BLACK             = $02 
  GREY              = $03
  LWHITE            = $06
  BWHITE            = $07
  LMAGENTA          = $A3 
  WHITE             = $AF
  RED               = $A2
  LRED              = $1A
  LPURPLE           = $1B
  PURPLE            = $03 
  LGREEN            = $1C
  LBLUE             = $1D
  SKYBLUE           = $1D
  YELLOW            = $1E
  BYELLOW           = $A6
  LGRAY             = $1F
  DGREY             = $08
  GREEN             = $A4
  ORANGE            = $06
  BLUE              = $A1 
  CYAN              = $1C
  MAGENTA           = $FC
  LYELLOW           = $1E

 '' ==== NO CHANGES REQUIRED PAST THIS POINT ====

 '' Change these colors to change DIR display colors

  wavfiles          = lgreen     'Display color of .WAV files in DIR
  hmufiles          = skyblue    'Display color of .HMU files in DIR
  binfiles          = yellow     'Display color of .BIN files in DIR
  basfiles          = lpurple    'Display color of .BAS files in DIR
  textcrayon        = white

  '' Key Assignments 

   fReturn   = 13
   bspKey    = $C8
   escape    = $CB
   backspace = 8

  CR                            = $0D
  LF                            = $0A
  TAB                           = $09
  BKS                           = $08

  sound_port                    = 10 


   
OBJ
     key   : "comboKeyboard"             ' Keyboard Driver
     text  : "aigeneric_driver"          ' AiGeneric Video Driver
     fsrw  : "fsrwFemto"                 ' SD Routines
     t     : "talk"  
            
VAR
     byte screen[1004] ' try not to use ODD sizes for buffers, can catch you out in the long run.
     long oldchr
     byte strbuff[5]
     
     '' Used for input routine load/save
     byte command[32]
     byte cline[26]  

     '' SD Vars
     byte f0[32]
     byte tbuf[20]
     long ioControl[2] 
     long tp
     
PUB mainProgram  | size, r,sta,bytes,totalscreen

  key.start(keyboard)
  text.start(video)
  fsrw.start(@ioControl)
  t.start(sound_port)
  t.set_speaker(0, 90)
  t.set_speaker(1, 110)
  t.set_speaker(2, 100)

  
  '' Check for required SD interface and PS2 Keyboard
  if \fsrw.mount(spiDO,spiClk,spiDI,spiCS) < 0
     text.str(string(13,"No SD card present.",CR))
     text.str(string("SD card expected on: "))
     text.dec(spiDO)
     text.str(string(", "))
     text.dec(spiClk)
     text.str(string(", "))
     text.dec(spiDI)
     text.str(string(", "))
     text.dec(spiCS)
     text.str(string(13,CR,"System halted.",CR)) 
     abort 
  waitcnt(clkfreq + cnt)
  if not key.present                                
     text.str(string(13,"No keyboard present",CR))
     text.str(string("Keyboard expected on: "))
     text.dec(keyboard)
     text.str(string(13,CR,"System halted.",CR))
     abort
 
  bytefill(@screen,1,1000)
  menu    '' Display menu/help screen
  menukey '' Get keys on menu/help screen


PUB menu 
  text.cls
  text.color(LGREEN)
  text.str(string("     PROPEDIT V1.2 BY JEFF LEDGER",13,13))
  text.out(13)
  text.out(13)
  text.color(LRED)
  text.str(string("PROPEDIT MAIN MENU",13))
  text.color(WHITE)
  text.str(string("------------------",13))
  text.out(13)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("ESC"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("TOGGLE BETWEEN EDITOR & MENU",13))
  text.out(13)
  
  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F1"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("DIRECTORY",13))
    
  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F2"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("LOAD FILE",13))

  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F3"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("SAVE FILE",13))

  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F4"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("CLEAR EDITOR",13))

  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F8"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("EXIT",13))
  
  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("F9"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGRAY)
  text.str(string("SPEAK",13,13))

  text.color(LGREEN)
  text.str(string("This editor is limited to one page.",13))
  text.str(string("This will change in future releases.",13))
  text.str(string("Press "))
  text.color(WHITE)
  text.str(string("["))
  text.color(LBLUE)
  text.str(string("ESC"))
  text.color(WHITE)
  text.str(string("] "))
  text.color(LGREEN)
  text.str(string("to begin editing.",13))

PUB menukey | keystroke,totalscreen,counter,newcount,r     

  repeat
    keystroke := key.getkey 

      if keystroke == 203 '' EDITOR                     -ESC
        text.cls
        totalscreen:=1
        repeat until totalscreen==1000
          text.out(screen[totalscreen])
          totalscreen++
        editor(@screen,1000)

      if keystroke == 208 '' DIRECTORY                  -F1
         text.cls
         dirw
         text.cls
         menu
         
      if keystroke == 209 '' LOAD FILE                  -F2
        text.out(13)
        bytefill(@command,0,32) 'Clear the command buffer
        bytefill(@cline,0,14) ' Clear commandline buffer
   
        text.str(string("LOAD: "))
        text.color(WHITE)
        input(@command,32)
        bytefill(@screen,1,1000)
        text.cls  
        '' Determine the filename
        counter := 0
        repeat until counter > 13
           if command[counter] > 0
             cline[counter] := command[counter]
           counter++
        '' Load the text into editor memory
        counter := 0
        r := fsrw.popen(@cline,"r")  
         repeat
           r := fsrw.pgetc
            if r < 0
              quit
            'if r > 0
              
            if r == 13
               r :=3
               text.out(3)
               text.out(13)
            if r > 13   
               text.out(r)
            if r == 0
              r :=1  
              
            screen[counter] := r
            ''text.out(screen[counter])
            counter++
        {text.cls
        totalscreen:=1
        repeat until totalscreen==1000
          text.out(screen[totalscreen])
          totalscreen++ }
        editor(@screen,1000)

      if keystroke == 210 '' SAVE FILE                  -F3
        text.out(13)
        bytefill(@command,0,32) 'Clear the command buffer
        bytefill(@cline,0,14) ' Clear commandline buffer
   
        text.str(string("SAVE: "))
        text.color(WHITE)
        input(@command,32)
        '' Determine the filename
        counter := 0
        repeat until counter > 13
           if command[counter] > 0
             cline[counter] := command[counter]
           counter++

           
        '' write the editor memory to a file
        counter := 1
        r := fsrw.popen(@cline,"w")
        repeat until counter > 999
          r := (screen[counter]) 
          if r == 1        '' Convert internal format to DOS standard
            r:=0
          if r == 3
            r:=13
          counter++
          fsrw.out(r)
        fsrw.pclose  
        text.cls
        menu

          
      if keystroke == 211 '' CLEAR EDITOR               -F4
          bytefill(@screen,1,1000) 'Clear editor data 
          text.cls
          menu
          
      if keystroke == 215 '' EXIT EDITOR                -F8
        reboot
      if keystroke == 216 '' TALK                       -F9 
        t.say(@screen) 
           
PUB editor(data, size) | keystroke,len,row,col,z,textcolor,rr,cc,sarea,char,checkchar 
   keystroke:=0
   len:=0
   row:=0
   col:=0
   textcolor:=white

   repeat

     oldchr:=text.GetChar(row,col) 'jb mod
     text.PokeChar(row,col,textcolor,$02)
     keystroke := key.getkey
     text.PutChar(row,col,oldchr)

''  CHECK FOR COLOR CHANGES  (Colors NOT saved in this version)

     if keystroke == 561  'Control+1
       textcolor:=lred
       keystroke :=0

     if keystroke == 562   'Control+2
       textcolor:=white
       keystroke :=0

     if keystroke == 563   'Control+3
      textcolor:=skyblue
      keystroke :=0

     if keystroke == 564   'Control+4
      textcolor:=purple
      keystroke :=0

''  CHECK CURSOR MOVEMENTS

     if keystroke == 13
       keystroke :=3 ''Screen driver friendly carriage returns 
      
     if keystroke == 195 and row < 24  'Cursor Down
       checkchar:=text.Getchar(row+1,col)
       
       if checkchar > 1537
         row++
         keystroke :=0

     if keystroke == 195
       keystroke :=0
      
     if keystroke == 194 and row > 0  'Cursor Up
       checkchar:=text.getchar(row-1,col)
       if checkchar > 1537 
          row--
          keystroke :=0

     if keystroke == 194
       keystroke :=0
      
     if keystroke == 192  'Cursor Left
       checkchar:=text.getchar(row,col-1)
       if checkchar > 1537
          col--
          keystroke :=0

     if keystroke == 192
       keystroke :=0

     if keystroke == $C8  'Backspace
       col--
       text.PokeChar(row,col,textcolor,1)
       keystroke :=0

     if keystroke == 193  'Cursor Right
       checkchar:=text.getchar(row,col+1)
       if checkchar > 1537
          col++
          keystroke := 0

     if keystroke == 193
       keystroke :=0

     if keystroke == 196 'HOME
       col:=0
       keystroke :=0

       
     if keystroke == 203 '' IF ESC STORE ENTIRE SCREEN TEXT IN SCREEN
      rr:=0
      cc:=0
      sarea:=1
      repeat until sarea==999
         char:=text.Getchar(rr,cc)
         screen[sarea]:=1537
         if char > 1537
            screen[sarea]:=char
         
         cc:=cc+1
         if cc==40
            cc:=0
            rr:=rr+1
         sarea++
      menu   
      return
       
     if col == 40
       col:=0
       row++
       
     if keystroke > 0  
      'text.dec(keystroke) 'Error checking  
      text.PokeChar(row,col,textcolor,keystroke)
      col++

     if keystroke == 3 and row < 24 ' ENTER
         row++
         col:=0
       
PUB input(data, size) | keystroke,len
   keystroke:=0
   len:=0
   text.out(02)
   repeat' until keystroke == 13 'Exit when Carriage Return is pressed
     keystroke := key.key
      if keystroke == $C8       ' Check for Backspace Key
        if len > 0
         byte[data--] := 0
         size++
         len--
         text.out(8)
         text.out(32) 'These lines erase the cursor on backspace
         text.out(8)
         
         text.out(8)
         text.out(32)
         text.out(8)
         text.out(02)
         keystroke := 0

      if keystroke == $C8        'Clean up backspace if all is cleared
         keystroke:= 0

      if keystroke == 13
         text.out(8)
         text.out(32)
         text.out(8)
         text.out(13)
         quit
         
      if keystroke > 10 
        if size > 1
          text.out(8)
          text.out(keystroke)
          text.out(02)
          
          'text.dec(keystroke) 'for troubleshooting
          if keystroke <> 13 
            byte[data++] := keystroke
            size--
            len++
PUB dirw | r, sta, bytes,b,d,tt,hidden

   text.out(13)
   text.str(string("Directory of SD", 13))
   text.out(13)
 
   fsrw.opendir                            
   b := 0
   hidden:= false                                  
   d := false                              
   repeat while fsrw.nextfile(@tbuf) == 0
      tt:=(StrRight(@tbuf,3))
      if textcomp(tt,string("HID"),3) == true
         hidden:=false ''display hidden files by default.
      if textcomp(tt,string("WAV"),3) == true
         text.color(wavfiles)
      if textcomp(tt,string("BIN"),3) == true
         text.color(binfiles)
      if textcomp(tt,string("HMU"),3) == true
         text.color(hmufiles)
      if textcomp(tt,string("BAS"),3) == true
         text.color(basfiles)    
      if hidden == false
        d := true                            
        if b == 39                         '' Grepped from FemtoBASIC
           text.out(13)                    '' Nice Wide Directory Listing!
           b := 0                                 
        text.str(@tbuf)
        text.color(textcrayon)                     
        repeat 13 - strsize(@tbuf)             
           text.out(" ")                      
        b := b + 13
      if hidden == true
         hidden := false                           
   if d                                    
      text.out(13)                      
      text.out(13)
      text.color(LPURPLE)
      text.str(string("    Press any key to continue:"))
      hidden := key.getkey 

PUB StrRight(str,len) | i,l,z,j

  l:=strSize(str)
  z:=0
  repeat i from l-len to l
    strbuff[z] := byte[@tbuf][i]
    z++
  return @strbuff

PRI textComp(str1,str2,len)
   repeat len
      if byte[str1++] <> byte[str2++]
         return false
   return true
          